(function() {
  var $, notify;

  $ = global.$;

  $ || ($ = require('jquery-browserify'));

  notify = function(message) {
    var close, container;

    container = $('<div></div>').addClass("alert alert-toast in");
    message = $('<p></p>').addClass("message").text(message).appendTo(container);
    close = $('<a></a>').addClass('close').html('&times;').attr('data-dismiss', 'alert').appendTo(container);
    container.appendTo('#message-center');
    return container.delay(10000).fadeOut('slow', function() {
      return $(this).remove();
    });
  };

  exports.notify = notify;

}).call(this);
