_ = require 'underscore'
$ = global.$
$ or= require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $

throwNotImplemented = ->
  throw new NotImplemented()

class NotImplemented extends Error
  constructor:(message) ->
    message or= ""
    super("Not Implemented. " + message)

exports.AssetGrid = Backbone.View.extend
  initialize: ->
    {collection, collectionClass, template} = @options
    @collectionClass = collectionClass
    @collectionClass or= Backbone.Collection
    @collection = collection
    @collection or= new @collectionClass
    @template = template
    @template or= ->
    @render()

  filter: _.bind(@, throwNotImplemented)
  addCollectionListeners: _.bind(@, throwNotImplemented)
  refreshCollection: _.bind(@, throwNotImplemented)

