$ = global.$
$ or= require 'jquery-browserify'
_ = require 'underscore'
Backbone = require 'backbone'
Backbone.$ = $
{uploadItem} = require './templates.js'

exports.UploadItem = Backbone.View.extend
  addEventListeners: ->
    @stopListening(@model, "all", @render)
    @listenTo(@model, "all", @render)
  cancelUpload: ->
    [request] = @model.requests
    if request?
      {requestId} = request
    @model.cancel(requestId)
  events:
    'click td.start button.btn' : "startUpload"
    'click td.cancel button.btn': 'cancelUpload'
  initialize: ->
    {template} = @options
    template or= uploadItem
    @template = template
    @addEventListeners()
  render: ->
    if(@model.get('progress') is 1)
      @remove()
    else
      context =
        id: @model.cid
        filename: @model.get('name')
        size: @model.get('size')
        hasError: false
        valid: true
        autoUpload: true
        progress: @model.get('progress') * 100
        startMsg: "Upload File"
        cancelMsg: "Cancel Upload"
      @undelegateEvents()
      $item = @getItemElement()
      if($item.length > 0)
        $item.replaceWith(uploadItem(context))
      else
        @$el.append(uploadItem(context))
      @delegateEvents(@events)
      @
  getItemElement: ->
    @$('#' + @model.cid, @$el)
  startUpload: ->
    @model.upload()
  remove: ->
    @stopListening()
    $item = @getItemElement()
    if($item.length > 0)
      $item.addClass('fade out')
      _.delay(
        ->
          $item.remove()
        301
      )
    @
    
