(function() {
  var $, Backbone, NotImplemented, throwNotImplemented, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  $ = global.$;

  $ || ($ = require('jquery-browserify'));

  Backbone = require('backbone');

  Backbone.$ = $;

  throwNotImplemented = function() {
    throw new NotImplemented();
  };

  NotImplemented = (function(_super) {
    __extends(NotImplemented, _super);

    function NotImplemented(message) {
      message || (message = "");
      NotImplemented.__super__.constructor.call(this, "Not Implemented. " + message);
    }

    return NotImplemented;

  })(Error);

  exports.AssetGrid = Backbone.View.extend({
    initialize: function() {
      var collection, collectionClass, template, _ref;

      _ref = this.options, collection = _ref.collection, collectionClass = _ref.collectionClass, template = _ref.template;
      this.collectionClass = collectionClass;
      this.collectionClass || (this.collectionClass = Backbone.Collection);
      this.collection = collection;
      this.collection || (this.collection = new this.collectionClass);
      this.template = template;
      this.template || (this.template = function() {});
      return this.render();
    },
    filter: _.bind(this, throwNotImplemented),
    addCollectionListeners: _.bind(this, throwNotImplemented),
    refreshCollection: _.bind(this, throwNotImplemented)
  });

}).call(this);
