(function() {
  var $, AssetCollection, AssetCollectionAssetGrid, AssetGrid, Backbone, ContentTypeHelpers, Handlebars, editorAssetsThumbnails, _;

  _ = require('underscore');

  $ = global.$;

  $ || ($ = require('jquery-browserify'));

  Backbone = require('backbone');

  Backbone.$ = $;

  Handlebars = require('handlebars');

  require('./CommonHandlebarsHelpers.js');

  AssetGrid = require('./AssetGrid.js').AssetGrid;

  AssetCollection = require('./asset/model/AssetCollection.js').AssetCollection;

  AssetCollectionAssetGrid = require('./AssetCollectionAssetGrid.js').AssetCollectionAssetGrid;

  ContentTypeHelpers = require('./ContentTypeHelpers.js').ContentTypeHelpers;

  editorAssetsThumbnails = require('./templates.js').editorAssetsThumbnails;

  exports.LocationDialogAssetGrid = AssetCollectionAssetGrid.extend({
    filter: function() {
      var filtered;

      filtered = this.collection.clone().filter(function(item) {
        return ContentTypeHelpers.extensionToContentType(item.get('filename'));
      });
      this.collection = new this.collectionClass().add(filtered);
      this.render();
      return this.collection;
    }
  });

}).call(this);
